package ludumdare18.behaviors
{
    import flash.geom.Point;
    import flash.geom.Rectangle;
    import ludumdare18.G;
	import stego.behavior.Base;
    import stego.GameObject;
    import stego.util.InputUtil;
    import stego.util.MathUtil;
    import stego.util.ObjectPool;
	
	/**
     * ...
     * @author Mike Meyer
     */
    public class EnemyBehavior extends Base
    {
        public var speed:Number = 100;
        public var accel:Number = 100;
        public var start:Point = new Point();
        public var end:Point = new Point();
        public var carried:Boolean = false;
        public var thrown:Boolean = false;

        protected var target:Point = start;

        public function EnemyBehavior(character:GameObject, inputUtil:InputUtil, startOnRight:Boolean)
        {
            super(character, inputUtil);

            carried = false;
            thrown = false;
            speed = 75;
            start.x = G.gameBounds.right - 30;
            start.y = G.gameBounds.bottom - 30;
            end.x = G.gameBounds.left + 30;
            end.y = G.gameBounds.bottom - 30;
            if (!startOnRight)
            {
                var temp:Point = start;
                start = end;
                end = temp;
            }
            target = start;
        }

        override public function update(elapsedTime:Number):void
        {
            super.update(elapsedTime);

            character.affectedByGravity = !carried;

            if (!carried && !thrown)
            {
                accelerate(elapsedTime);

                if ( character.getCollisionBounds().containsPoint(target) )
                {
                    target = (target == start) ? end : start;
                }
            }
        }

        protected function accelerate(elapsedTime:Number):void
        {
            var tempPoint_current:Point = ObjectPool.getObject(Point);
            tempPoint_current.x = character.dx;
            tempPoint_current.y = character.dy;
            var tempPoint_target:Point = ObjectPool.getObject(Point);
            tempPoint_target.x = target.x - character.x;
            tempPoint_target.y = target.y - character.y;
            tempPoint_target.normalize(speed);

            var v:Point = MathUtil.moveToward2d(tempPoint_current, tempPoint_target, accel * elapsedTime);
            character.dx = v.x;
            character.dy = v.y;

            ObjectPool.returnObject(Point, tempPoint_current);
            ObjectPool.returnObject(Point, tempPoint_target);
        }
    }
}
