package ludumdare18.behaviors
{
    import stego.behavior.Base;
    import stego.behavior.IBehavior;
    import stego.constants.Keyboard;
    import stego.util.InputUtil;
    import stego.gameobject.PlatformerCharacter;
    import stego.util.MathUtil;

    /**
     * flight controls
     * @author Mike Meyer
     */
    public class Fly extends Base
    {
        /** array of keys than you can use to thrust */
        public var thrustKeys:Array = [Keyboard.SPACE, Keyboard.SHIFT, Keyboard.UP, Keyboard.Z];

        /** how fast we can go upward */
        public var maxVerticalSpeed:Number = 600;

        /** how hard the thrusters push. high because it has to outrace the pull of gravity */
        public var thrustAccel:Number = 2200;

        /**
         * constructor
         * @param	character
         * @param	inputUtil
         */
        public function Fly(character:PlatformerCharacter, inputUtil:InputUtil)
        {
            super(character, inputUtil);
        }

        /**
         * process one frame of controls
         */
        override public function update(elapsedTime:Number):void
        {
            if (inputUtil.anyDown(thrustKeys))
            {
                character.dy = MathUtil.moveToward(character.dy, -maxVerticalSpeed, thrustAccel * elapsedTime);
            }

            character.dy = MathUtil.clamp(character.dy, -maxVerticalSpeed, maxVerticalSpeed);
        }
    }
}
