package ludumdare18.gamestate
{
    import flash.events.Event;
    import flash.geom.Rectangle;
    import ludumdare18.G;
    import stego.constants.Colors;
    import stego.GameInterface;
    import stego.GameObject;
    import stego.GameState;
    import stego.util.GuiBuilder;
    import stego.util.MathUtil;
    import stego.util.scene.GameObjectHolder;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Instructions extends GameState
    {
        [Embed(source='../../../assets/tutorial1.png')]
        protected const TUT_IMAGE_1:Class;
        [Embed(source='../../../assets/tutorial2.png')]
        protected const TUT_IMAGE_2:Class;
        [Embed(source='../../../assets/tutorial3.png')]
        protected const TUT_IMAGE_3:Class;

        protected var _effectsLayer:GameObjectHolder;
        protected var _guiLayer:GameObjectHolder;
        protected var _builder:GuiBuilder;

        /**
         * create scene
         */
        public override function begin(game:GameInterface):void
        {
            super.begin(game);

            G.gameBounds = new Rectangle( -300, 0, 1200, 400);

            _guiLayer = game.layers.addLayer();
            _builder = new GuiBuilder(game.stageRect, _guiLayer);
            _builder.fontColor = Colors.WHITE_ENOUGH;
            _builder.highlightColor = Colors.WHITE;
            _builder.fontSize = 16;

            partOne();
        }

        private function partOne():void
        {
            _guiLayer.removeAll();

            _builder.addGraphicCentered(TUT_IMAGE_1, 0.5, 0.15);
            _builder.addTextCentered("use the arrow keys to move", 0.5, 0.25);
            _builder.addGraphicCentered(TUT_IMAGE_2, 0.5, 0.5);
            _builder.addTextCentered("use z or c to jump", 0.5, 0.7);
            _builder.addPulsingButtonCentered("next >", startGame, 0.75, 0.9);
        }

        private function partTwo(e:Event = null):void
        {
            _guiLayer.removeAll();

            _builder.fontSize = 12;
            _builder.addGraphicCentered(TUT_IMAGE_3, 0.8, 0.5);
            _builder.addTextCentered("when on an enemy", 0.3, 0.15);
            _builder.addTextCentered("press x or space", 0.3, 0.45);
             _builder.addTextCentered("to lift", 0.3, 0.5);
            _builder.addTextCentered("press again to throw", 0.3, 0.8);
            _builder.addPulsingButtonCentered("click to start", startGame, 0.3, 0.95);
        }

        /**
         *
         */
        override public function end():void
        {
            super.end();
            game.layers.remove(_guiLayer);
        }

        /**
         *
         */
        public function startGame(e:Event = null):void
        {
            game.changeGameState(new Instructions2());
        }
    }

}
