package ludumdare18.gamestate
{
    import flash.events.Event;
    import flash.geom.Rectangle;
    import ludumdare18.behaviors.ParallaxBehavior;
    import ludumdare18.G;
    import ludumdare18.gameobjects.Background;
    import stego.constants.Colors;
    import stego.GameInterface;
    import stego.GameObject;
    import stego.GameState;
    import stego.util.GuiBuilder;
    import stego.util.MathUtil;
    import stego.util.scene.GameObjectHolder;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Title extends GameState
    {
        protected var _effectsLayer:GameObjectHolder;
        protected var _guiLayer:GameObjectHolder;

        /**
         * create scene
         */
        public override function begin(game:GameInterface):void
        {
            super.begin(game);

            G.gameBounds = new Rectangle( -300, 0, 1200, 400);

            _effectsLayer = game.layers.addLayer();
            var background:Background;
            var period:Number = 30.0;
            var randomizeFunctionOrder:Boolean = true;
            var scrollScale:Number = 1.0;
            var scrollScaleStep:Number = -0.125;
            var scrollY:int = 1;
            for (var i:uint = 0; i < 3; ++i)
            {
                background = _effectsLayer.add(Background) as Background;
                background.x = MathUtil.lerp(G.gameBounds.x, 0, scrollScale);
                background.y = MathUtil.lerp(G.gameBounds.y, 0, scrollScale);
                background.width = MathUtil.lerp( G.gameBounds.width, game.stageWidth, scrollScale);
                background.height = MathUtil.lerp( G.gameBounds.height, game.stageHeight, scrollScale);
                background.timeBetweenPatternChanges = period;
                background.randomizeFunctionOrder = randomizeFunctionOrder;
                background.addBehavior(new ParallaxBehavior(background, game, scrollScale, background.x, background.y));
                background.scrollY = scrollY;
                period *= 0.618033989;
                period *= 0.618033989;
                randomizeFunctionOrder = false;
                scrollScale += scrollScaleStep;
                scrollY += 1;
            }

            _guiLayer = game.layers.addLayer();
            var builder:GuiBuilder = new GuiBuilder(game.stageRect, _guiLayer);
            builder.fontColor = Colors.WHITE_ENOUGH;
            builder.highlightColor = Colors.WHITE;
            builder.fontSize = 32;
            builder.addTextCentered("Survive", 0.5, 0.2);
            builder.addTextCentered("for", 0.5, 0.4);
            builder.addTextCentered("60 Seconds", 0.5, 0.6);
            builder.fontSize = 16;
            builder.addPulsingButtonCentered("click to start", startGame, 0.5, 0.8);
        }

        /**
         *
         */
        override public function end():void
        {
            super.end();
            game.layers.remove(_guiLayer);
        }

        /**
         *
         */
        public function startGame(e:Event = null):void
        {
            game.changeGameState(new Instructions());
        }
    }

}
