package ludumdare18.gamestate
{
    import flash.events.Event;
    import stego.constants.Colors;
    import stego.GameInterface;
    import stego.GameObject;
    import stego.GameState;
    import stego.ui.Fader;
    import stego.util.GuiBuilder;
    import stego.util.scene.GameObjectHolder;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Victory extends GameState
    {
        protected var _guiLayer:GameObjectHolder;
        protected var _fader:Fader;

        /**
         * create scene
         */
        public override function begin(game:GameInterface):void
        {
            super.begin(game);

            _guiLayer = game.layers.addLayer();
            var builder:GuiBuilder = new GuiBuilder(game.stageRect, _guiLayer);
            builder.fontColor = Colors.WHITE_ENOUGH;
            builder.highlightColor = Colors.WHITE;
            builder.fontSize = 32;
            builder.addTextCentered("You won!", 0.5, 0.4);
            builder.fontSize = 16;
            builder.addPulsingButtonCentered("go again", startGame, 0.5, 0.8);

            _fader = _guiLayer.add(Fader) as Fader;
            _fader.fadeToColor(0, Colors.WHITE);
            _fader.fadeBack(1, fadeDone);
            _fader.x = 0.5 * game.stageWidth;
            _fader.y = 0.5 * game.stageHeight;
        }

        private function fadeDone():void
        {
            _guiLayer.remove(_fader);
            _fader = null;
        }

        /**
         *
         */
        override public function end():void
        {
            super.end();
            game.layers.remove(_guiLayer);
        }

        /**
         *
         */
        public function startGame(e:Event = null):void
        {
            game.changeGameState(new Playing());
        }
    }

}
