﻿package stego
{
    /**
     * ...
     * @author Mike Meyer
     */
    public interface GameStateInterface
    {
        /**
         * "heartbeat" function. called every frame
         */
        function update():void

        /**
         * called every frame to integrate object motion
         */
        function integrate():void

        /**
         * called every frame before collisions
         */
        function preCollision():void

        /**
         * called every frame to check collision
         */
        function collision():void

        /**
         * last-minute updating before things get rendered each frame
         */
        function preDraw():void

        /**
         * Go back to the beginning
         */
        function restart():void

        /**
         * get the gamestate ready to be played
         */
        function begin(game:GameInterface):void

        /**
         * clean up
         */
        function end():void
    }
}
