﻿package stego.debug
{
    import flash.events.Event;
    import flash.utils.getTimer;
    import stego.constants.Colors;
    import stego.GameInterface;
    import stego.GameObject;
    import stego.ui.TextField;
    /**
     * ...
     * @author Mike Meyer
     */
    public class FpsCounter extends GameObject
    {
        private var textField:TextField;
        private var lastUpdated:int;

        private static const movingAverageWindowSize:uint = 60;
        private var frameTimeValues:/*int */Array;
        private var curIndex:uint;

        public override function init(game:GameInterface):void
        {
            super.init(game);

            if (null == textField)
            {
                textField = new TextField();
                this.addChild(textField);
                textField.init(game);
                textField.x = 2;
                textField.y = 2;
            }

            frameTimeValues = [];
            curIndex = 0;

            textField.setFontColor(Colors.WHITE);
            textField.setText("-");

            lastUpdated = getTimer();
        }

        public override function update(elapsedTime:Number):void
        {
            super.update(elapsedTime);

            var currentTime:int = getTimer();
            frameTimeValues[curIndex] = currentTime-lastUpdated;
            curIndex = (curIndex + 1) % movingAverageWindowSize;

            var total:int  = 0;
            for each (var value:int in frameTimeValues)
            {
                total += value;
            }
            var average:Number = (total / frameTimeValues.length);
            var frameRate:Number = 1000.0 / average;

            textField.setText( String(frameRate.toFixed(2)) + " / " + stage.frameRate );
            lastUpdated = currentTime;
        }
    }

}
