﻿package stego.script.step
{
    import stego.script.Step;

    /**
     * Step to loop a bunch of other steps N times
     * @author Mike Meyer
     */
    public class LoopWhile extends Step
    {
        private var _condition:Function;
        private var _steps:/*Step*/Array;
        private var _nextStep:Number;

        public function LoopWhile(cond:Function, steps:Array)
        {
            _condition = cond;
            _nextStep = 0;
            _steps = steps.concat(); // make a copy
        }

        /**
         * Play the next step in the loop
         */
        public override function execute(timeDelta:Number):Boolean
        {
            // early out if we're done
            if (true != _condition())
            {
                return true;
            }

            // don't crash on empty steplists
            if (0 < _steps.length)
            {
                var step:Step = _steps[_nextStep];

                if (step.execute(timeDelta))
                {
                    ++_nextStep;
                }

                if (_nextStep >= _steps.length)
                {
                    _nextStep = 0;
                }
            }

            return false;
        }
    }

}
